<?php
class Mail {
	protected $to;
	protected $from;
	protected $sender;
	protected $subject;
	protected $text;
	protected $html;
	protected $attachments = array();
	public $protocol = 'mail';
	public $hostname;
	public $username;
	public $password;
	public $port = 25;
	public $timeout = 5;
	public $newline = "\n";
	public $crlf = "\r\n";
	public $verp = false;
	public $parameter = '';
	private $registry;


	public function __construct($registry = null) {
		if ($registry) {
			$this->registry = $registry;
		}
	}

	public function __get($name)
	{
		return $this->registry->get($name);
	}

	public function setTo($to) {
		$this->to = $to;
	}

	public function setFrom($from) {
		$this->from = $from;
	}

	public function setSender($sender) {
		$this->sender = $sender;
	}

	public function setSubject($subject) {
		$this->subject = $subject;
	}

	public function setText($text) {
		$this->text = $text;
	}

	public function clearText(){
		$this->text = '';
	}

	public function setHtml($html) {
		$this->html = $html;
	}

	public function clearHtml(){
		$this->html = '';
	}

	public function addAttachment($filename) {
		$this->attachments[] = $filename;
	}

	public function setErroMail($error, $notify){
		if($notify){
			throw new Exception($error);
		}else{
			trigger_error($error);
			exit();
		}
	}

	public function send($notify=false) {
		if (!$this->to) {
			$this->setErroMail('Error: E-Mail to required!', $notify);
		}

		if (!$this->from && !in_array($this->protocol, ['gmail', 'outlook'])) {
			$this->setErroMail('Error: E-Mail from required!', $notify);
		}

		if (!$this->sender) {
			$this->setErroMail('Error: E-Mail sender required!', $notify);
		}

		if (!$this->subject) {
			$this->setErroMail('Error: E-Mail subject required!', $notify);
		}

		if ((!$this->text) && (!$this->html)) {
			$this->setErroMail('Error: E-Mail message required!', $notify);
		}

		if (is_array($this->to)) {
			$to = implode(',', $this->to);
		} else {
			$to = $this->to;
		}

		if (!in_array($this->protocol, ['gmail', 'outlook'])) {

			$boundary = '----=_NextPart_' . md5(time());
	
			$header = '';
	
			$header .= 'MIME-Version: 1.0' . $this->newline;
	
			if ($this->protocol != 'mail') {
				$header .= 'To: ' . $to . $this->newline;
				$header .= 'Subject: ' . $this->subject . $this->newline;
			}
	
			$header .= 'Date: ' . date('D, d M Y H:i:s O') . $this->newline;
			$header .= 'From: ' . '=?UTF-8?B?' . base64_encode($this->sender) . '?=' . '<' . $this->from . '>' . $this->newline;
			$header .= 'Reply-To: ' . '=?UTF-8?B?' . base64_encode($this->sender) . '?=' . '<' . $this->from . '>' . $this->newline;
			$header .= 'Return-Path: ' . $this->from . $this->newline;
			$header .= 'X-Mailer: PHP/' . phpversion() . $this->newline;
			$header .= 'Content-Type: multipart/related; charset="utf-8"; boundary="' . $boundary . '"' . $this->newline . $this->newline;
		}

		if (!$this->html) {
			$message  = '';
			if (!in_array($this->protocol, ['gmail', 'outlook'])) {
				$message .= '--' . $boundary . $this->newline;
				$message .= 'Content-Type: text/plain; charset="utf-8"' . $this->newline;
				$message .= 'Content-Transfer-Encoding: 8bit' . $this->newline . $this->newline;
			}
			$message .= $this->text . $this->newline;
		} else {
			$message  = '';
			if (!in_array($this->protocol, ['gmail', 'outlook'])) {
				$message .= '--' . $boundary . $this->newline;
				$message .= 'Content-Type: multipart/alternative; boundary="' . $boundary . '_alt"' . $this->newline . $this->newline;
				$message .= '--' . $boundary . '_alt' . $this->newline;
				$message .= 'Content-Type: text/plain; charset="utf-8"' . $this->newline;
				$message .= 'Content-Transfer-Encoding: 8bit' . $this->newline . $this->newline;
			}
			if ($this->text) {
				$message .= $this->text . $this->newline;
			} else if(!in_array($this->protocol, ['gmail', 'outlook'])) {
				$message .= 'This is a HTML email and your email client software does not support HTML email!' . $this->newline;
			}

			if (!in_array($this->protocol, ['gmail', 'outlook'])) {
				$message .= '--' . $boundary . '_alt' . $this->newline;
				$message .= 'Content-Type: text/html; charset="utf-8"' . $this->newline;
				$message .= 'Content-Transfer-Encoding: 8bit' . $this->newline . $this->newline;
			}
			$message .= $this->html . $this->newline;
			if (!in_array($this->protocol, ['gmail', 'outlook'])) {
				$message .= '--' . $boundary . '_alt--' . $this->newline;
			}
		}

		foreach ($this->attachments as $attachment) {
			if (file_exists($attachment)) {
				$handle = fopen($attachment, 'r');

				$content = fread($handle, filesize($attachment));

				fclose($handle);

				if (!in_array($this->protocol, ['gmail', 'outlook'])) {
					$message .= '--' . $boundary . $this->newline;
					$message .= 'Content-Type: application/octet-stream; name="' . basename($attachment) . '"' . $this->newline;
					$message .= 'Content-Transfer-Encoding: base64' . $this->newline;
					$message .= 'Content-Disposition: attachment; filename="' . basename($attachment) . '"' . $this->newline . $this->newline;
					$message .= chunk_split(base64_encode($content));
				} else {
					$attachmentData = [
						"name" => basename($attachment),
						"contentBytes" => chunk_split(base64_encode($content)),
						"contentType" => mime_content_type($attachment)
					];
				}
			}
		}

		if (!in_array($this->protocol, ['gmail', 'outlook'])) {
			$message .= '--' . $boundary . '--' . $this->newline;
		}

		if ($this->protocol == 'mail') {
			ini_set('sendmail_from', $this->from);

			if ($this->parameter) {
				mail($to, '=?UTF-8?B?' . base64_encode($this->subject) . '?=', $message, $header, $this->parameter);
			} else {
				mail($to, '=?UTF-8?B?' . base64_encode($this->subject) . '?=', $message, $header);
			}
		} elseif ($this->protocol == 'smtp') {
            if (substr($this->hostname, 0, 3) == 'tls') {
                $hostname = substr($this->hostname, 6);
            } else {
                $hostname = $this->hostname;
            }

			$handle = fsockopen($hostname, $this->port, $errno, $errstr, $this->timeout);

			if (!$handle) {
				$this->setErroMail('Error: ' . $errstr . ' (' . $errno . ')', $notify);
			} else {
				if (substr(PHP_OS, 0, 3) != 'WIN') {
					socket_set_timeout($handle, $this->timeout, 0);
				}

				while ($line = fgets($handle, 515)) {
					if (substr($line, 3, 1) == ' ') {
						break;
					}
				}

				if (substr($this->hostname, 0, 3) == 'tls') {
					fputs($handle, 'STARTTLS' . $this->crlf);

                    $reply = '';
					while ($line = fgets($handle, 515) !== false) {
						$reply .= $line;

						if (substr($line, 3, 1) == ' ') {
							break;
						}
					}

					if (substr($reply, 0, 3) != 220) {
						$this->setErroMail('Error: STARTTLS not accepted from server!', $notify);
					}
				}

				if (!empty($this->username)  && !empty($this->password)) {
					fputs($handle, 'EHLO ' . getenv('SERVER_NAME') . $this->crlf);

					$reply = '';

					while ($line = fgets($handle, 515)) {
						$reply .= $line;

						if (substr($line, 3, 1) == ' ') {
							break;
						}
					}

					if (substr($reply, 0, 3) != 250) {
						$this->setErroMail('Error: EHLO not accepted from server!', $notify);
					}

					fputs($handle, 'AUTH LOGIN' . $this->crlf);

					$reply = '';

					while ($line = fgets($handle, 515)) {
						$reply .= $line;

						if (substr($line, 3, 1) == ' ') {
							break;
						}
					}

					if (substr($reply, 0, 3) != 334) {
						$this->setErroMail('Error: AUTH LOGIN not accepted from server!', $notify);
					}

					fputs($handle, base64_encode($this->username) . $this->crlf);

					$reply = '';

					while ($line = fgets($handle, 515)) {
						$reply .= $line;

						if (substr($line, 3, 1) == ' ') {
							break;
						}
					}

					if (substr($reply, 0, 3) != 334) {
						$this->setErroMail('Error: Username not accepted from server!', $notify);
					}

					fputs($handle, base64_encode($this->password) . $this->crlf);

					$reply = '';

					while ($line = fgets($handle, 515)) {
						$reply .= $line;

						if (substr($line, 3, 1) == ' ') {
							break;
						}
					}

					if (substr($reply, 0, 3) != 235) {
						$this->setErroMail('Error: Password not accepted from server!', $notify);
					}
				} else {
					fputs($handle, 'HELO ' . getenv('SERVER_NAME') . $this->crlf);

					$reply = '';

					while ($line = fgets($handle, 515)) {
						$reply .= $line;

						if (substr($line, 3, 1) == ' ') {
							break;
						}
					}

					if (substr($reply, 0, 3) != 250) {
						$this->setErroMail('Error: HELO not accepted from server!', $notify);
					}
				}

				if ($this->verp) {
					fputs($handle, 'MAIL FROM: <' . $this->from . '>XVERP' . $this->crlf);
				} else {
					fputs($handle, 'MAIL FROM: <' . $this->from . '>' . $this->crlf);
				}

				$reply = '';

				while ($line = fgets($handle, 515)) {
					$reply .= $line;

					if (substr($line, 3, 1) == ' ') {
						break;
					}
				}

				if (substr($reply, 0, 3) != 250) {
					$this->setErroMail('Error: MAIL FROM not accepted from server!', $notify);
				}

				if (!is_array($this->to)) {
					fputs($handle, 'RCPT TO: <' . $this->to . '>' . $this->crlf);

					$reply = '';

					while ($line = fgets($handle, 515)) {
						$reply .= $line;

						if (substr($line, 3, 1) == ' ') {
							break;
						}
					}

					if ((substr($reply, 0, 3) != 250) && (substr($reply, 0, 3) != 251)) {
						$this->setErroMail('Error: RCPT TO not accepted from server!', $notify);
					}
				} else {
					foreach ($this->to as $recipient) {
						fputs($handle, 'RCPT TO: <' . $recipient . '>' . $this->crlf);

						$reply = '';

						while ($line = fgets($handle, 515)) {
							$reply .= $line;

							if (substr($line, 3, 1) == ' ') {
								break;
							}
						}

						if ((substr($reply, 0, 3) != 250) && (substr($reply, 0, 3) != 251)) {
							$this->setErroMail('Error: RCPT TO not accepted from server!', $notify);
						}
					}
				}

				fputs($handle, 'DATA' . $this->crlf);

				$reply = '';

				while ($line = fgets($handle, 515)) {
					$reply .= $line;

					if (substr($line, 3, 1) == ' ') {
						break;
					}
				}

				if (substr($reply, 0, 3) != 354) {
					$this->setErroMail('Error: DATA not accepted from server!', $notify);
				}

				// According to rfc 821 we should not send more than 1000 including the CRLF
				$message = str_replace("\r\n", "\n",  $header . $message);
				$message = str_replace("\r", "\n", $message);

				$lines = explode("\n", $message);

				foreach ($lines as $line) {
					$results = str_split($line, 998);

					foreach ($results as $result) {
						if (substr(PHP_OS, 0, 3) != 'WIN') {
							fputs($handle, $result . $this->crlf);
						} else {
							fputs($handle, str_replace("\n", "\r\n", $result) . $this->crlf);
						}
					}
				}

				fputs($handle, '.' . $this->crlf);

				$reply = '';

				while ($line = fgets($handle, 515)) {
					$reply .= $line;

					if (substr($line, 3, 1) == ' ') {
						break;
					}
				}

				if (substr($reply, 0, 3) != 250) {
					$this->setErroMail('Error: DATA not accepted from server!', $notify);
				}

				fputs($handle, 'QUIT' . $this->crlf);

				$reply = '';

				while ($line = fgets($handle, 515)) {
					$reply .= $line;

					if (substr($line, 3, 1) == ' ') {
						break;
					}
				}

				if (substr($reply, 0, 3) != 221) {
					$this->setErroMail('Error: QUIT not accepted from server!', $notify);
				}

				fclose($handle);
			}
		} else if (in_array($this->protocol, ['gmail', 'outlook'])) {
			$data = [
				'to' => $this->to,
				'subject' => $this->subject,
				'type' => $this->html ? 'HTML' : 'Text', 
				'message' => $message
			];

			if (isset ($attachmentData) && !empty($attachmentData)) {
				$data['attachments'] = [$attachmentData];
			}

			$sended = $this->protocol == 'gmail' ? $this->gmailapi->sendMessage($data) : $this->outlookapi->sendMessage($data);
			if (!$sended) {
				throw new Exception('Erro ao enviar email ' . ucwords($this->protocol));
			}
		}	
	}
}
